diff --git a/src/odbc/unittests/timeout2.c b/src/odbc/unittests/timeout2.c
index 1c61565..0d5802d 100644
--- a/src/odbc/unittests/timeout2.c
+++ b/src/odbc/unittests/timeout2.c
@@ -14,7 +14,7 @@
  * Test from Ou Liu, cf "Query Time Out", 2006-08-08
  */
 
-static char software_version[] = "$Id: timeout2.c,v 1.5 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: timeout2.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #if defined(__MINGW32__) || defined(WIN32)
@@ -24,7 +24,6 @@ static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 int
 main(int argc, char *argv[])
 {
-	SQLRETURN ret;
 	int i;
 
 	Connect();
@@ -36,17 +35,15 @@ main(int argc, char *argv[])
 
 		printf("Loop %d\n", i);
 
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 10, SQL_IS_UINTEGER));
+		CHKSetStmtAttr(SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 10, SQL_IS_UINTEGER, "S");
 
-		CHK(SQLPrepare, (Statement, (SQLCHAR*) "select * from #timeout", SQL_NTS));
-		CHK(SQLExecute, (Statement));
+		CHKPrepare((SQLCHAR*) "select * from #timeout", SQL_NTS, "S");
+		CHKExecute("S");
 
 		do {
-			while ((ret=SQLFetch(Statement)) == SQL_SUCCESS)
+			while (CHKFetch("SNo") == SQL_SUCCESS)
 				;
-			assert(ret == SQL_NO_DATA);
-		} while ((ret = SQLMoreResults(Statement)) == SQL_SUCCESS);
-		assert(ret == SQL_NO_DATA);
+		} while (CHKMoreResults("SNo") == SQL_SUCCESS);
 
 		if (i == 0) {
 			printf("Sleep 15 seconds to test if timeout occurs\n");
diff --git a/src/odbc/unittests/timeout3.c b/src/odbc/unittests/timeout3.c
index 8fdeff3..ae15217 100644
--- a/src/odbc/unittests/timeout3.c
+++ b/src/odbc/unittests/timeout3.c
@@ -40,7 +40,7 @@
 	test connection timeout
 */
 
-static char software_version[] = "$Id: timeout3.c,v 1.7 2008/02/08 09:28:05 freddy77 Exp $";
+static char software_version[] = "$Id: timeout3.c,v 1.8 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -48,18 +48,9 @@ static void init_connect(void);
 static void
 init_connect(void)
 {
-	if (SQLAllocEnv(&Environment) != SQL_SUCCESS) {
-		fprintf(stderr, "Unable to allocate env\n");
-		exit(1);
-	}
-
+	CHKR(SQLAllocEnv, (&Environment), "S");
 	SQLSetEnvAttr(Environment, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) (SQL_OV_ODBC3), SQL_IS_UINTEGER);
-
-	if (SQLAllocConnect(Environment, &Connection) != SQL_SUCCESS) {
-		fprintf(stderr, "Unable to allocate connection\n");
-		SQLFreeEnv(Environment);
-		exit(1);
-	}
+	CHKR(SQLAllocConnect, (Environment, &Connection), "S");
 }
 
 static pthread_t      fake_thread;
@@ -128,7 +119,6 @@ fake_thread_proc(void * arg)
 int
 main(int argc, char *argv[])
 {
-	int res;
 	char tmp[2048];
 	char sqlstate[6];
 	SQLSMALLINT len;
@@ -167,31 +157,19 @@ main(int argc, char *argv[])
 	printf("Fake server binded at port %d\n", port);
 
 	init_connect();
-	res = SQLSetConnectAttr(Connection, SQL_ATTR_CONNECTION_TIMEOUT, (SQLPOINTER) 10, sizeof(SQLINTEGER));
-	if (!SQL_SUCCEEDED(res))
-		ODBC_REPORT_ERROR("SQLSetConnectAttr error");
-	res = SQLSetConnectAttr(Connection, SQL_ATTR_LOGIN_TIMEOUT, (SQLPOINTER) 10, sizeof(SQLINTEGER));
-	if (!SQL_SUCCEEDED(res))
-		ODBC_REPORT_ERROR("SQLSetConnectAttr error");
+	CHKSetConnectAttr(SQL_ATTR_CONNECTION_TIMEOUT, (SQLPOINTER) 10, sizeof(SQLINTEGER), "SI");
+	CHKSetConnectAttr(SQL_ATTR_LOGIN_TIMEOUT, (SQLPOINTER) 10, sizeof(SQLINTEGER), "SI");
 
 	/* this is expected to work with unixODBC */
 	printf("try to connect to our port just to check connection timeout\n");
 	sprintf(tmp, "DRIVER=FreeTDS;SERVER=127.0.0.1;Port=%d;TDS_Version=7.0;UID=test;PWD=test;DATABASE=tempdb;", port);
 	start_time = time(NULL);
-	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
-	if (SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "SQLDriverConnect should fail (res=%d)\n", (int) res);
-		return 1;
-	}
+	CHKR(SQLDriverConnect, (Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT), "E");
 	end_time = time(NULL);
 
 	strcpy(sqlstate, "XXXXX");
 	tmp[0] = 0;
-	res = SQLGetDiagRec(SQL_HANDLE_DBC, Connection, 1, (SQLCHAR *) sqlstate, NULL, (SQLCHAR *) tmp, sizeof(tmp), NULL);
-	if (!SQL_SUCCEEDED(res)) {
-		printf("SQLGetDiagRec should not fail\n");
-		return 1;
-	}
+	CHKGetDiagRec(SQL_HANDLE_DBC, Connection, 1, (SQLCHAR *) sqlstate, NULL, (SQLCHAR *) tmp, sizeof(tmp), NULL, "SI");
 	Disconnect();
 	CLOSESOCKET(fake_sock);
 	pthread_join(fake_thread, NULL);
diff --git a/src/odbc/unittests/timeout4.c b/src/odbc/unittests/timeout4.c
index be9c6f9..14e3edd 100644
--- a/src/odbc/unittests/timeout4.c
+++ b/src/odbc/unittests/timeout4.c
@@ -39,7 +39,7 @@
  * prepare or execute a query. This should fail and return an error message.
  */
 
-static char software_version[] = "$Id: timeout4.c,v 1.2 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: timeout4.c,v 1.3 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #if HAVE_FSTAT && defined(S_IFSOCK)
@@ -80,7 +80,7 @@ static int
 Test(int direct)
 {
 	char buf[256];
-	SQLRETURN ret;
+	SQLRETURN RetCode;
 	char sqlstate[6];
 	time_t start_time, end_time;
 
@@ -91,28 +91,19 @@ Test(int direct)
 		return 1;
 	}
 
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 10, SQL_IS_UINTEGER));
+	CHKSetStmtAttr(SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 10, SQL_IS_UINTEGER, "S");
 
 	alarm(30);
 	start_time = time(NULL);
 	if (direct)
-		ret = SQLExecDirect(Statement, (SQLCHAR *) "SELECT 1", SQL_NTS);
+		CHKExecDirect((SQLCHAR *) "SELECT 1", SQL_NTS, "E");
 	else
-		ret = SQLPrepare(Statement, (SQLCHAR *) "SELECT 1", SQL_NTS);
+		CHKPrepare((SQLCHAR *) "SELECT 1", SQL_NTS, "E");
 	end_time = time(NULL);
 	alarm(0);
-	if (ret != SQL_ERROR) {
-		fprintf(stderr, "Error expected\n");
-		return 1;
-	}
 
 	strcpy(sqlstate, "XXXXX");
-	ret = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL);
-	if (ret != SQL_SUCCESS && ret != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Error not set\n");
-		Disconnect();
-		return 1;
-	}
+	CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) sqlstate, NULL, (SQLCHAR *) buf, sizeof(buf), NULL, "SI");
 	sqlstate[5] = 0;
 	printf("Message: %s - %s\n", sqlstate, buf);
 	if (strcmp(sqlstate, "HYT00") || !strstr(buf, "Timeout")) {
diff --git a/src/odbc/unittests/transaction.c b/src/odbc/unittests/transaction.c
index e7b507a..a7408a9 100644
--- a/src/odbc/unittests/transaction.c
+++ b/src/odbc/unittests/transaction.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: transaction.c,v 1.13 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: transaction.c,v 1.14 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int
@@ -35,35 +35,35 @@ Test(int discard_test)
 	Command(Statement, createErrorProcedure);
 
 	/* Start transaction */
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0));
+	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0, "S");
 
 	/* Insert a value */
 	Command(Statement, "EXEC testinsert 1");
 
 	/* we should be able to read row count */
-	CHK(SQLRowCount, (Statement, &rows));
+	CHKRowCount(&rows, "S");
 
 	/* Commit transaction */
-	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, SQL_COMMIT));
+	CHKEndTran(SQL_HANDLE_DBC, Connection, SQL_COMMIT, "S");
 
 	SQLCloseCursor(Statement);
 
 	/* Start transaction */
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0));
+	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_OFF, 0, "S");
 
 	/* Insert another value */
 	Command(Statement, "EXEC testinsert 2");
 
 	/* Roll back transaction */
-	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, SQL_ROLLBACK));
+	CHKEndTran(SQL_HANDLE_DBC, Connection, SQL_ROLLBACK, "S");
 
 	/* TODO test row inserted */
 
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_ON, 0));
+	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, (void *) SQL_AUTOCOMMIT_ON, 0, "S");
 
 	/* generate an error */
 	Command(Statement, "EXEC testerror");
-	CHK(SQLBindCol, (Statement, 1, SQL_C_SLONG, &out_buf, sizeof(out_buf), &out_len));
+	CHKBindCol(1, SQL_C_SLONG, &out_buf, sizeof(out_buf), &out_len, "S");
 
 	while ((result = SQLFetch(Statement)) == SQL_SUCCESS) {
 		printf("\t%ld\n", (long int) out_buf);
diff --git a/src/odbc/unittests/transaction2.c b/src/odbc/unittests/transaction2.c
index 8c54082..25f3dda 100644
--- a/src/odbc/unittests/transaction2.c
+++ b/src/odbc/unittests/transaction2.c
@@ -3,7 +3,7 @@
 
 /* Test transaction types */
 
-static char software_version[] = "$Id: transaction2.c,v 1.4 2008/03/18 08:22:23 freddy77 Exp $";
+static char software_version[] = "$Id: transaction2.c,v 1.5 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -14,25 +14,20 @@ ReadError(void)
 {
 	memset(odbc_err, 0, sizeof(odbc_err));
 	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
-	if (!SQL_SUCCEEDED
-	    (SQLGetDiagRec
-	     (SQL_HANDLE_DBC, Connection, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL))) {
-		printf("SQLGetDiagRec should not fail\n");
-		exit(1);
-	}
+	CHKGetDiagRec(SQL_HANDLE_DBC, Connection, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL, "SI");
 	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
 }
 
 static void
 AutoCommit(int onoff)
 {
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_AUTOCOMMIT, int2ptr(onoff), 0));
+	CHKSetConnectAttr(SQL_ATTR_AUTOCOMMIT, int2ptr(onoff), 0, "S");
 }
 
 static void
 EndTransaction(SQLSMALLINT type)
 {
-	CHK(SQLEndTran, (SQL_HANDLE_DBC, Connection, type));
+	CHKEndTran(SQL_HANDLE_DBC, Connection, type, "S");
 }
 
 #define SWAP(t,a,b) do { t xyz = a; a = b; b = xyz; } while(0)
@@ -61,10 +56,8 @@ CheckDirtyRead(void)
 		return 0;	/* no dirty read */
 	}
 
-	CHK(SQLFetch, (Statement));
-	ret = SQLFetch(Statement);
-	if (ret != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("other rows ??");
+	CHKFetch("S");
+	CHKFetch("No");
 	SQLMoreResults(Statement);
 	EndTransaction(SQL_ROLLBACK);
 	SWAP_CONN();
@@ -79,7 +72,7 @@ CheckNonrepeatableRead(void)
 
 	/* transaction 2 read a row */
 	SWAP_CONN();
-	CHK(CommandWithResult, (Statement, "SELECT * FROM test_transaction WHERE t = 'initial' AND n = 1"));
+	Command(Statement, "SELECT * FROM test_transaction WHERE t = 'initial' AND n = 1");
 	SQLMoreResults(Statement);
 
 	/* transaction 1 change a row and commit */
@@ -99,10 +92,8 @@ CheckNonrepeatableRead(void)
 	/* second transaction try to fetch commited row */
 	Command(Statement, "SELECT * FROM test_transaction WHERE t = 'second' AND n = 1");
 
-	CHK(SQLFetch, (Statement));
-	ret = SQLFetch(Statement);
-	if (ret != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("other rows ??");
+	CHKFetch("S");
+	CHKFetch("No");
 	SQLMoreResults(Statement);
 	EndTransaction(SQL_ROLLBACK);
 	SWAP_CONN();
@@ -118,7 +109,7 @@ CheckPhantom(void)
 
 	/* transaction 2 read a row */
 	SWAP_CONN();
-	CHK(CommandWithResult, (Statement, "SELECT * FROM test_transaction WHERE t = 'initial'"));
+	Command(Statement, "SELECT * FROM test_transaction WHERE t = 'initial'");
 	SQLMoreResults(Statement);
 
 	/* transaction 1 insert a row that match critera */
@@ -138,11 +129,9 @@ CheckPhantom(void)
 	/* second transaction try to fetch commited row */
 	Command(Statement, "SELECT * FROM test_transaction WHERE t = 'initial'");
 
-	CHK(SQLFetch, (Statement));
-	CHK(SQLFetch, (Statement));
-	ret = SQLFetch(Statement);
-	if (ret != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("other rows ??");
+	CHKFetch("S");
+	CHKFetch("S");
+	CHKFetch("No");
 	SQLMoreResults(Statement);
 	EndTransaction(SQL_ROLLBACK);
 	SWAP_CONN();
@@ -158,7 +147,7 @@ static int global_txn;
 static void
 my_attrs(void)
 {
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(global_txn), 0));
+	CHKSetConnectAttr(SQL_ATTR_TXN_ISOLATION, int2ptr(global_txn), 0, "S");
 	AutoCommit(SQL_AUTOCOMMIT_OFF);
 }
 
@@ -181,9 +170,9 @@ Test(int txn, const char *expected)
 	if (test_with_connect) {
 		Disconnect();
 		ConnectWithTxn(txn);
-		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
+		CHKSetStmtAttr(SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0, "S");
 	} else {
-		CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(txn), 0));
+		CHKSetConnectAttr(SQL_ATTR_TXN_ISOLATION, int2ptr(txn), 0, "S");
 	}
 	SWAP_CONN();
 
@@ -219,7 +208,7 @@ main(int argc, char *argv[])
 	Command(Statement, "IF OBJECT_ID('test_transaction') IS NOT NULL DROP TABLE test_transaction");
 	Command(Statement, "CREATE TABLE test_transaction(n NUMERIC(18,0) PRIMARY KEY, t VARCHAR(30))");
 
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
+	CHKSetStmtAttr(SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0, "S");
 
 	AutoCommit(SQL_AUTOCOMMIT_OFF);
 	Command(Statement, "INSERT INTO test_transaction(n, t) VALUES(1, 'initial')");
@@ -258,7 +247,7 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
+	CHKSetStmtAttr(SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0, "S");
 	AutoCommit(SQL_AUTOCOMMIT_OFF);
 
 	SWAP_CONN();
diff --git a/src/odbc/unittests/typeinfo.c b/src/odbc/unittests/typeinfo.c
index c9539c9..b15c930 100644
--- a/src/odbc/unittests/typeinfo.c
+++ b/src/odbc/unittests/typeinfo.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: typeinfo.c,v 1.9 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: typeinfo.c,v 1.10 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -20,30 +20,28 @@ TestName(int index, const char *expected_name)
 	} while(0)
 
 	/* retrieve with SQLDescribeCol */
-	CHK(SQLDescribeCol, (Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL));
+	CHKDescribeCol(index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL, "S");
 	NAME_TEST;
 
 	/* retrieve with SQLColAttribute */
-	CHK(SQLColAttribute, (Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL));
+	CHKColAttribute(index, SQL_DESC_NAME, name, sizeof(name), &len, NULL, "S");
 	if (db_is_microsoft())
 		NAME_TEST;
-	CHK(SQLColAttribute, (Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL));
+	CHKColAttribute(index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL, "S");
 	NAME_TEST;
 }
 
 static void
 FlushStatement(void)
 {
-	SQLRETURN retcode;
+	SQLRETURN RetCode;
 
-	while ((retcode = SQLFetch(Statement)) == SQL_SUCCESS);
-	if (retcode != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("SQLFetch failed");
+	while (CHKFetch("SNo") == SQL_SUCCESS)
+		;
 
 	/* Sybase store procedure seems to return extra empty results */
-	while ((retcode = SQLMoreResults(Statement)) == SQL_SUCCESS);
-	if (retcode != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("SQLMoreResults failed");
+	while (CHKMoreResults("SNo") == SQL_SUCCESS)
+		;
 }
 
 static void
@@ -51,12 +49,12 @@ CheckType(SQLSMALLINT type, SQLSMALLINT expected, const char *string_type, int l
 {
 	SQLSMALLINT out_type;
 	SQLLEN ind;
+	SQLRETURN RetCode;
 
-	if (!SQL_SUCCEEDED(SQLBindCol(Statement, 2, SQL_C_SSHORT, &out_type, 0, &ind)))
-		ODBC_REPORT_ERROR("SQLBindCol failed");
-	if (!SQL_SUCCEEDED(SQLGetTypeInfo(Statement, type)))
-		ODBC_REPORT_ERROR("SQLGetTypeInfo failed");
-	switch (SQLFetch(Statement)) {
+	CHKBindCol(2, SQL_C_SSHORT, &out_type, 0, &ind, "SI");
+	CHKGetTypeInfo(type, "SI");
+	CHKFetch("SNo");
+	switch (RetCode) {
 	case SQL_SUCCESS:
 		if (expected == SQL_UNKNOWN_TYPE) {
 			fprintf(stderr, "Data not expected (type %d - %s) line %d\n", type, string_type, line);
@@ -76,8 +74,6 @@ CheckType(SQLSMALLINT type, SQLSMALLINT expected, const char *string_type, int l
 			exit(1);
 		}
 		break;
-	default:
-		ODBC_REPORT_ERROR("SQLFetch failed");
 	}
 
 	SQLFreeStmt(Statement, SQL_UNBIND);
@@ -101,8 +97,7 @@ DoTest(int version3)
 	printf("Using ODBC version %d\n", version3 ? 3 : 2);
 
 	/* test column name */
-	if (!SQL_SUCCEEDED(SQLGetTypeInfo(Statement, SQL_ALL_TYPES)))
-		ODBC_REPORT_ERROR("SQLGetTypeInfo failed");
+	CHKGetTypeInfo(SQL_ALL_TYPES, "SI");
 	TestName(1, "TYPE_NAME");
 	TestName(2, "DATA_TYPE");
 	TestName(3, version3 ? "COLUMN_SIZE" : "PRECISION");
@@ -150,23 +145,15 @@ DoTest(int version3)
 	/* varchar/nvarchar before sysname */
 
 	/* test binding (not all column, required for Oracle) */
-	if (!SQL_SUCCEEDED(SQLGetTypeInfo(Statement, SQL_ALL_TYPES)))
-		ODBC_REPORT_ERROR("SQLGetTypeInfo failed");
-	if (!SQL_SUCCEEDED(SQLBindCol(Statement, 1, SQL_C_CHAR, name, sizeof(name), &ind1)))
-		ODBC_REPORT_ERROR("SQLBindCol failed");
-	if (!SQL_SUCCEEDED(SQLBindCol(Statement, 2, SQL_C_SSHORT, &type, 0, &ind2)))
-		ODBC_REPORT_ERROR("SQLBindCol failed");
-	if (!SQL_SUCCEEDED(SQLBindCol(Statement, 3, SQL_C_SLONG, &col_size, 0, &ind3)))
-		ODBC_REPORT_ERROR("SQLBindCol failed");
-	if (!SQL_SUCCEEDED(SQLBindCol(Statement, 6, SQL_C_CHAR, params, sizeof(params), &ind4)))
-		ODBC_REPORT_ERROR("SQLBindCol failed");
-	if (!SQL_SUCCEEDED(SQLBindCol(Statement, 10, SQL_C_SSHORT, &is_unsigned, 0, &ind5)))
-		ODBC_REPORT_ERROR("SQLBindCol failed");
-	if (!SQL_SUCCEEDED(SQLBindCol(Statement, 14, SQL_C_SSHORT, &min_scale, 0, &ind6)))
-		ODBC_REPORT_ERROR("SQLBindCol failed");
-	while ((retcode = SQLFetch(Statement)) == SQL_SUCCESS);
-	if (retcode != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("SQLFetch failed");
+	CHKGetTypeInfo(SQL_ALL_TYPES, "SI");
+	CHKBindCol(1, SQL_C_CHAR, name, sizeof(name), &ind1, "SI");
+	CHKBindCol(2, SQL_C_SSHORT, &type, 0, &ind2, "SI");
+	CHKBindCol(3, SQL_C_SLONG, &col_size, 0, &ind3, "SI");
+	CHKBindCol(6, SQL_C_CHAR, params, sizeof(params), &ind4, "SI");
+	CHKBindCol(10, SQL_C_SSHORT, &is_unsigned, 0, &ind5, "SI");
+	CHKBindCol(14, SQL_C_SSHORT, &min_scale, 0, &ind6, "SI");
+	while (CHKFetch("SNo") == SQL_SUCCESS)
+		;
 	SQLFreeStmt(Statement, SQL_UNBIND);
 	FlushStatement();
 
diff --git a/src/odbc/unittests/utf8.c b/src/odbc/unittests/utf8.c
index 31f57d6..328914f 100755
--- a/src/odbc/unittests/utf8.c
+++ b/src/odbc/unittests/utf8.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 /* test binding with UTF-8 encoding */
-static char software_version[] = "$Id: utf8.c,v 1.7 2008/10/31 14:35:23 freddy77 Exp $";
+static char software_version[] = "$Id: utf8.c,v 1.8 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -17,26 +17,21 @@ init_connect(void)
 static void
 CheckNoRow(const char *query)
 {
-	SQLRETURN retcode;
+	SQLRETURN RetCode;
 
-	retcode = SQLExecDirect(Statement, (SQLCHAR *) query, SQL_NTS);
-	if (retcode == SQL_NO_DATA)
+	CHKExecDirect((SQLCHAR *) query, SQL_NTS, "SINo");
+	if (RetCode == SQL_NO_DATA)
 		return;
 
-	if (!SQL_SUCCEEDED(retcode))
-		ODBC_REPORT_ERROR("SQLExecDirect");
-
 	do {
 		SQLSMALLINT cols;
 
-		retcode = SQLNumResultCols(Statement, &cols);
-		if (retcode != SQL_SUCCESS || cols != 0) {
+		CHKNumResultCols(&cols, "S");
+		if (cols != 0) {
 			fprintf(stderr, "Data not expected here, query:\n\t%s\n", query);
 			exit(1);
 		}
-	} while ((retcode = SQLMoreResults(Statement)) == SQL_SUCCESS);
-	if (retcode != SQL_NO_DATA)
-		ODBC_REPORT_ERROR("SQLMoreResults");
+	} while (CHKMoreResults("SNo") == SQL_SUCCESS);
 }
 
 /* test table name, it contains two japanese characters */
@@ -77,9 +72,9 @@ TestBinding(int minimun)
 
 	/* insert with SQLPrepare/SQLBindParameter/SQLExecute */
 	sprintf(tmp, "INSERT INTO %s VALUES(?,?,?)", table_name);
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) tmp, SQL_NTS));
-	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_LONG,
-		SQL_INTEGER, 0, 0, &n, 0, &n_len));
+	CHKPrepare((SQLCHAR *) tmp, SQL_NTS, "S");
+	CHKBindParameter(1, SQL_PARAM_INPUT, SQL_C_LONG,
+		SQL_INTEGER, 0, 0, &n, 0, &n_len, "S");
 	n_len = sizeof(n);
 	
 	for (n = 1, p = strings; p[0] && p[1]; p += 2, ++n) {
@@ -87,16 +82,16 @@ TestBinding(int minimun)
 		int len;
 
 		len = minimun ? (strlen(strings_hex[p-strings]) - 2) /4 : 40;
-		CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_CHAR,
-			SQL_WCHAR, len, 0, (void *) p[0], 0, &s1_len));
+		CHKBindParameter(2, SQL_PARAM_INPUT, SQL_C_CHAR,
+			SQL_WCHAR, len, 0, (void *) p[0], 0, &s1_len, "S");
 		len = minimun ? (strlen(strings_hex[p+1-strings]) - 2) /4 : 40;
 		/* FIXME this with SQL_VARCHAR produce wrong protocol data */
-		CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_INPUT, SQL_C_CHAR,
-			SQL_WVARCHAR, len, 0, (void *) p[1], 0, &s2_len));
+		CHKBindParameter(3, SQL_PARAM_INPUT, SQL_C_CHAR,
+			SQL_WVARCHAR, len, 0, (void *) p[1], 0, &s2_len, "S");
 		s1_len = strlen(p[0]);
 		s2_len = strlen(p[1]);
 		printf("insert #%d\n", (int) n);
-		CHK(SQLExecute, (Statement));
+		CHKExecute("S");
 	}
 
 	/* check rows */
@@ -111,7 +106,6 @@ TestBinding(int minimun)
 int
 main(int argc, char *argv[])
 {
-	int res;
 	SQLSMALLINT len;
 	const char * const*p;
 	SQLINTEGER n;
@@ -122,12 +116,7 @@ main(int argc, char *argv[])
 	/* connect string using DSN */
 	init_connect();
 	sprintf(tmp, "DSN=%s;UID=%s;PWD=%s;DATABASE=%s;ClientCharset=UTF-8;", SERVER, USER, PASSWORD, DATABASE);
-	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
-		CheckReturn();
-		return 1;
-	}
+	CHKR(SQLDriverConnect, (Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT), "SI");
 	if (!driver_is_freetds()) {
 		Disconnect();
 		printf("Driver is not FreeTDS, exiting\n");
@@ -140,7 +129,7 @@ main(int argc, char *argv[])
 		return 0;
 	}
 
-	CHK(SQLAllocStmt, (Connection, &Statement));
+	CHKAllocStmt(&Statement, "S");
 
 	/* create test table */
 	sprintf(tmp, "IF OBJECT_ID(N'%s') IS NOT NULL DROP TABLE %s", table_name, table_name);
diff --git a/src/odbc/unittests/utf8_2.c b/src/odbc/unittests/utf8_2.c
index 7203a40..7e18402 100755
--- a/src/odbc/unittests/utf8_2.c
+++ b/src/odbc/unittests/utf8_2.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 /* test conversion of Hebrew characters (which have shift sequences) */
-static char software_version[] = "$Id: utf8_2.c,v 1.5 2008/10/31 14:35:23 freddy77 Exp $";
+static char software_version[] = "$Id: utf8_2.c,v 1.6 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void init_connect(void);
@@ -37,7 +37,6 @@ main(int argc, char *argv[])
 	char tmp[128];
 	char out[32];
 	SQLLEN n_len;
-	int res;
 	SQLSMALLINT len;
 	const char * const*p;
 	int n;
@@ -48,12 +47,7 @@ main(int argc, char *argv[])
 	/* connect string using DSN */
 	init_connect();
 	sprintf(tmp, "DSN=%s;UID=%s;PWD=%s;DATABASE=%s;ClientCharset=UTF-8;", SERVER, USER, PASSWORD, DATABASE);
-	res = SQLDriverConnect(Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT);
-	if (!SQL_SUCCEEDED(res)) {
-		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
-		CheckReturn();
-		return 1;
-	}
+	CHKR(SQLDriverConnect, (Connection, NULL, (SQLCHAR *) tmp, SQL_NTS, (SQLCHAR *) tmp, sizeof(tmp), &len, SQL_DRIVER_NOPROMPT), "SI");
 	if (!driver_is_freetds()) {
 		Disconnect();
 		printf("Driver is not FreeTDS, exiting\n");
@@ -66,7 +60,7 @@ main(int argc, char *argv[])
 		return 0;
 	}
 
-	CHK(SQLAllocStmt, (Connection, &Statement));
+	CHKAllocStmt(&Statement, "S");
 
 	/* create test table */
 	Command(Statement, "CREATE TABLE #tmpHebrew (i INT, v VARCHAR(10) COLLATE Hebrew_CI_AI)");
@@ -81,9 +75,9 @@ main(int argc, char *argv[])
 	Command(Statement, "SELECT v FROM #tmpHebrew");
 
 	/* insert with SQLPrepare/SQLBindParameter/SQLExecute */
-	CHK(SQLBindCol, (Statement, 1, SQL_C_CHAR, out, sizeof(out), &n_len));
+	CHKBindCol(1, SQL_C_CHAR, out, sizeof(out), &n_len, "S");
 	for (n = 0, p = strings; p[n]; ++n) {
-		CHK(SQLFetch, (Statement));
+		CHKFetch("S");
 		if (n_len != strlen(p[n]) || strcmp(p[n], out) != 0) {
 			fprintf(stderr, "Wrong row %d %s\n", n, out);
 			Disconnect();
diff --git a/src/odbc/unittests/warning.c b/src/odbc/unittests/warning.c
index 741a250..b1fd195 100644
--- a/src/odbc/unittests/warning.c
+++ b/src/odbc/unittests/warning.c
@@ -14,7 +14,7 @@
  * inside recordset
  * Sybase do not return warning but test works the same
  */
-static char software_version[] = "$Id: warning.c,v 1.6 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: warning.c,v 1.7 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char one_null_with_warning[] = "select max(a) as foo from (select convert(int, null) as a) as test";
@@ -28,23 +28,15 @@ static const int tds_no_dm = 0;
 static void
 Test(const char *query)
 {
-	int res;
+	SQLRETURN RetCode;
 
-	CHK(SQLPrepare, (Statement, (SQLCHAR *) query, SQL_NTS));
+	CHKPrepare((SQLCHAR *) query, SQL_NTS, "S");
 
-	CHK(SQLExecute, (Statement));
+	CHKExecute("S");
 
-	res = SQLFetch(Statement);
-	if (res != SQL_SUCCESS && res != SQL_SUCCESS_WITH_INFO) {
-		fprintf(stderr, "Unable to fetch row.\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHKFetch("SI");
 
-	if (SQLFetch(Statement) != SQL_NO_DATA) {
-		fprintf(stderr, "Warning was returned as a result row -- bad!\n");
-		exit(1);
-	}
+	CHKFetch("No");
 
 	/*
 	 * Microsoft SQL Server 2000 provides a diagnostic record
@@ -57,10 +49,7 @@ Test(const char *query)
 	if (db_is_microsoft() && tds_no_dm) {
 		SQLCHAR output[256];
 
-		if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL))) {
-			fprintf(stderr, "SQLGetDiagRec should not fail\n");
-			exit(1);
-		}
+		CHKGetDiagRec(SQL_HANDLE_STMT, Statement, 1, NULL, NULL, output, sizeof(output), NULL, "SI");
 		printf("Message: %s\n", (char *) output);
 	}
 
diff --git a/src/odbc/unittests/wchar.c b/src/odbc/unittests/wchar.c
index 92bb084..d3698e7 100644
--- a/src/odbc/unittests/wchar.c
+++ b/src/odbc/unittests/wchar.c
@@ -2,7 +2,7 @@
 
 /* test SQL_C_DEFAULT with NCHAR type */
 
-static char software_version[] = "$Id: wchar.c,v 1.1 2008/02/05 10:03:57 freddy77 Exp $";
+static char software_version[] = "$Id: wchar.c,v 1.2 2008/11/04 10:59:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -12,16 +12,15 @@ main(int argc, char *argv[])
 	SQLLEN ind;
 	int failed = 0;
 
-	/* TODO remove if not neeeded */
 	use_odbc_version3 = 1;
 	Connect();
 
-	SQLBindCol(Statement, 1, SQL_C_DEFAULT, buf, 100, &ind);
+	CHKBindCol(1, SQL_C_DEFAULT, buf, 100, &ind, "S");
 	Command(Statement, "SELECT CONVERT(NCHAR(10), 'Pippo 123')");
 
 	/* get data */
 	memset(buf, 0, sizeof(buf));
-	SQLFetch(Statement);
+	CHKFetch("S");
 
 	SQLMoreResults(Statement);
 	SQLMoreResults(Statement);

